﻿Imports ThinkGeo.MapSuite.DesktopEdition
Imports ThinkGeo.MapSuite.Core
Public Class Form1
   Private Const NAD_83_16N As Integer = 26916
   Private Const USA_Albers As Integer = 102003
   Private msCountyPath As String = "..\..\Data\OneCountyAlbers.shp"
   Private msPolyPath As String = "..\..\Data\SmallPoly.shp"
   Private msRoadPath As String = "..\..\Data\Road.shp"


   Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      Dim oOverlay As New LayerOverlay
      Dim oShapeFile As ShapeFileFeatureLayer
      Dim oExtent As RectangleShape
      Dim oProj As ManagedProj4Projection

      Me.TextBox1.Text = "Notice that there are three layers. The shape with the gray background is a single county " &
                         "in the Albers coordinate system (USA Contiguous). The other two layers are in coordinate " &
                         "system NAD 83 Zone 16 N. Projection objects have been applied to the NAD 83 layers so that " &
                         "they align correctly with the county layer. If you zoom out slowly you will notice that the " &
                         "line layer (in red) disappears. As you continue to zoom out the polygon layer (outlined in blue) " &
                         "also disappears."


      oShapeFile = New ShapeFileFeatureLayer(msCountyPath)
      oShapeFile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.County1
      oShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      oOverlay.Layers.add("County", oShapeFile)

      oProj = New ManagedProj4Projection(ManagedProj4Projection.GetEsriParametersString(NAD_83_16N), ManagedProj4Projection.GetEsriParametersString(USA_Albers))
      oShapeFile = New ShapeFileFeatureLayer(msPolyPath)
      oShapeFile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
      oShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      oOverlay.Layers.Add("Poly", oShapeFile)
      oShapeFile.FeatureSource.Projection = oProj
      oShapeFile.Open()
      oExtent = oShapeFile.GetBoundingBox

      oShapeFile = New ShapeFileFeatureLayer(msRoadPath)
      oShapeFile.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Red, 3, False)
      oShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      oOverlay.Layers.Add("Road", oShapeFile)
      oShapeFile.FeatureSource.Projection = oProj

      moMap.MapUnit = GeographyUnit.Meter
      moMap.Overlays.Add("LayerOverlay", oOverlay)
      moMap.CurrentExtent = oExtent
      moMap.Refresh()

   End Sub
End Class
